Location other[6];
int8_t other_size=0;
int8_t regs[6];
float p[6];
	
void init_servos(){
	servo_set_pos(0,460); //pull up lever
	servo_set_pos(4,511); //close gate
}

void setTeam() {
	Location loc = getVPSCurrentLocation(NULL, NULL);
	while(loc.x ==0 && loc.y==0){
		loc = getVPSCurrentLocation(NULL, NULL);
	}

	team = (loc.x>=0)?0:1; // 0 = blue, 1 = red

}

float getCollisionDist()
{
	Location a = getVPSCurrentLocation(NULL, NULL), b = getOpponentLocation();	
	return getDistance(&a, &b);
}

int8_t getRegion(uint8_t onlyDistance, Location *current) { 
		// perform optimization and return the id of the most optimal mine
	// factors: distance, remaning balls>=5 and limit rate if there's any, the location of the  opponent, remaning time...

	Location c;
	
	if(current == NULL) {
		c = getVPSCurrentLocation(NULL, NULL);
		current = &c;	
	}
	
	int8_t i, region = 0;
	float dist = 0, temp_dist = 0;
	
	if(onlyDistance) {
		for (i=0; i<6; i++) {
			if (!onlyDistance) if(rateLimit(i) > 6 || remainingBalls(i) == 0) continue;

			temp_dist = getDistance(current,&midpoint[i]);
			if (temp_dist <= dist || !i) {
				dist = temp_dist;
				region = i;
			}
		}
		return region; 
	}
	
	region = getRegion(1, current);
	Location other = getOpponentLocation();
	int8_t other_region = getRegion(1, &other), k=-1;
	
	/*
	PLAN!
		formula = (10-distance_in_regions) * min(5, remaining_balls) * (other_robot_in_path)?0.2 : 1 
						* (6 - max(0, rateLimit - 1.5*distance_in_regions - 3))
	
	
		get the region with the maximum formula
	*/
	
	regs[0] = region;
	for(i=1; i<6; i+=2) {
		regs[i] = (region-(i+1)/2+12)%6;
		if(i!=5) regs[i+1] = (region+(i+1)/2)%6;
	}
	
	for(i=0; i<6; ++i) {
		if(other_region == regs[i]) k = i;
		//* (6-max(0, rateLimit(regs[i]) - 1.5*((i+1)/2) - 3)) *
		p[i] = ((float)(8-i)) * (min(5.0, ((float)remainingBalls(regs[i])))+0.7) * ((isCaptured(regs[i]))?0.7:1) * ((k!=-1 && !((i-k)%2))?0.2:1);
		
		if(dumped && !isCaptured(regs[i])) p[i] /= 5.0;
	}
	
	k = 0;
	for(i=1;i<6;++i)
		if(p[i] > p[k]) k = i;
		
	return regs[k];
}

void capture(uint8_t region){
	uint32_t timeout = get_time();
	
	startScrolling();
	motorRight(15); motorLeft(15);
	while(!isCaptured(region) && (get_time()-timeout) < 1700);
	stopScrolling();
}

int8_t doMine(uint8_t pulls, int8_t region){
	servo_set_pos(0,460); //pull up lever
	
	int8_t balls = remainingBalls(region);
	
	for (int i=0;i<pulls;++i) {
		if(!isCaptured(region)) {
			servo_set_pos(0,460);
			return 2;
		}
		servo_set_pos(0,135); //down
		pause(400);
		servo_set_pos(0,380); //up -temp
		pause(360); //350
		if(remainingBalls(region) == balls) return 0;
	}
	servo_set_pos(0,460); //pull up lever
	return 1;
}

void dumpBalls(){
	gotoLocation(&alwaysOne, &midpoint[getRegion(1,NULL)], 0);
	
	int8_t disp[2][3] = {{1,2,3}, {4,5,0}};  // possible dispensing sites
	int8_t i, region = getRegion(1, NULL);
	Location opponent;
	
	for(i=0;i<6;++i) {
		dispenserrr[i].x = dispenser[i].x * 1.25;
		dispenserrr[i].y = dispenser[i].y * 1.25;
	}
	
	for(i=0;i<3;++i)
		if(region == disp[team][i]) break;
	
	assumeArrival = 0;
	
	if(i > 2) {
		/*if(abs(region-disp[team][0]) < abs(region-disp[team][2]))
			gotoLocationSmart(&alwaysOne, &dispenserrr[disp[team][0]], 1);
		else gotoLocationSmart(&alwaysOne, &dispenserrr[disp[team][2]], 1);*/
		
		opponent = getOpponentLocation();
		int8_t best=10, j=0, op_region = getRegion(1, &opponent);
		
		for(i=0; i<3; ++i) {
			if(op_region == disp[team][i]) continue;
			if(best > getRegionDis(region, disp[team][i], op_region)) {
				best = 	getRegionDis(region, disp[team][i], op_region);
				j = i;
			}
		}
		
		gotoLocationSmart(&alwaysOne, &dispenser[disp[team][j]], 1);
	}
	else gotoLocationSmart(&alwaysOne, &dispenser[disp[team][i]], 1);
	
	assumeArrival = 1;
	
	//moveTillCollide(255);

	motorRight(255); motorLeft(255);
	pause(200);
	servo_set_pos(4,170);
	pause(2000);
	servo_set_pos(4,511); //close gate
	
	stopRobot();
	pause(20);
	motorRight(-200); motorLeft(-200);
	pause(80);
	stopRobot();
	
	dumped = 1;
}

void dominateRegion(uint8_t region)
{
	Location loc, loc2, loc3;
	int8_t balls, ret;
	
	while(1) {
		balls = -1;
		loc = midPoint(&gearbox[region], &midpoint[region]);
		loc2 = midPoint(&loc, &midpoint[region]);
		
		goingTo = 3;
		gotoLocationSmart(&alwaysOne,&loc2,0);
		//gotoLocationSmart(&alwaysOne,&midpoint[region],0);
		goingTo = 0;
		
		while (!isCaptured(region)){
			if(get_time() - start_time > TIME_TO_DUMP && !dumped) {dumpBalls(); return;} // TODO: add time limit (10 sec?)
			if(balls!=-1) {
				gotoLocation(&alwaysOne,&loc, 0);
				pause(50);
			}
		
			balls = 0;
			
			goingTo = 1;
			gotoLocation(&alwaysOne, &gearbox[region], 1);
			goingTo = 0;
		
			capture(region);
		}

		loc = midPoint(&mine[region], &midpoint[region]);
		loc2 = midPoint(&loc, &midpoint[region]);
		loc = midPoint(&loc, &loc2);
		
		if(balls == -1) {
			goingTo = 3;
			gotoLocationSmart(&alwaysOne,&loc2, 0);
			goingTo = 0;
		}
		else {
			loc2 = midPoint(&mine[region], &midpoint[region]);
			loc2 = midPoint(&loc2, &midpoint[region]);
			
			loc3 = midPoint(&gearbox[region], &midpoint[region]);
			loc2 = midPoint(&loc2, &midpoint[region]);
			
			loc3 = midPoint(&loc2, &loc3);
			//loc2 = midPoint(&loc2, &loc3);
			gotoLocation(&alwaysOne, &loc3, 0);
		}
		
		balls = -1;
	
		do {
			if(get_time() - start_time > TIME_TO_DUMP && !dumped) {dumpBalls(); return;}
			
			if(!remainingBalls(region)) return;
			stopRobot();
			
			//TODO make it stop at midpoint to get it from the first time..
			if(balls != -1) {
				gotoLocation(&alwaysOne,&loc, 0);
				pause(150);
			}
			
			/*gotoLocation(&alwaysOne,&loc, (balls!=-1)?0:-1);
			if(balls!=-1) pause(150);
			*/
			goingTo = 2;
			gotoLocation(&alwaysOne, &mine[region], -1);
			goingTo = 0;
	
			motorRight(-12); motorLeft(-12); // push against the wall
			balls = remainingBalls(region);
			
			ret = doMine((balls>5)?5:balls, region);
		} while(!ret);
		if(ret == 1) break; //leave it like this (1).
	}
	
	stopRobot();
	motorRight(160);
	motorLeft(160);
	pause(220);
	stopRobot();
	
	gotoLocation(&alwaysOne,&loc, 0);
}

void explore() { // first 10 seconds
	int16_t r, region = getRegion(1, NULL);
	isExploring = 1;
	int8_t done = 0, ret;
	
	r = region;
	
	for(int8_t i=0;i<6;++i) {
		mids[i].x = midpoint[i].x*1.1;
		mids[i].y = midpoint[i].y*1.1;
	}
	
	for(int16_t i=1; i<2000; ++i) {
		ret = gotoLocation(&alwaysOne, &mids[(r+i)%6], 0);
		if(ret == 3)
			r = getRegion(1, NULL) - i - 1;
		else {
			if(other_size < 6) other[other_size++] = getOpponentLocation();
			if((r+i)%6 != region) done = 1;
			if(ret == 4) break;
		}
		
		if((r+i+2)%6 == region) isExploring = 0;
		if(done && (r+i+1)%6 == region) break;
		/*if(gotoLocation(&alwaysOne, &midpoint[(region+i)%6], 0) == 3)
			while(getRegion(1, NULL) != (region+i)%6)
				gotoLocationSmart(&alwaysOne, &midpoint[(region+i)%6], 0);
		*/
		//if(i == 5) isExploring = 0;
	}
	
	isExploring = 0;
	stopRobot();
}

int8_t getAdjacent() //returns the first region to go to.. 
{
	int8_t i,beg,a,b,dir=0;
	
	beg = b = getRegion(1, &other[0]);
	
	for(i=1; i<other_size; ++i) {
		a = b;
		b = getRegion(1, &other[i]);
		
		if(abs(b-a) > 3) dir += b-a - signOf(b-a)*6;
		else dir += b-a;
	}
	
	//(dir): positive --> counter-clockwise, negative --> clockwise, zero --> unknown (didn't move maybe)
	 
	if(!dir) return getRegion(1, NULL);
	else if(dir > 0) return (beg-2+6)%6; 
	else return beg;
}
